/*
  A2

machine
  0 -- 1

display
  1 -- 2

 */

#include "qchar.h"

extern Wttable highestweight;

void show_vertex()
{
  fprintf(stderr,"   1 -- 2\n");
}

Vertex no_vertex(Vertex no)
{

#ifdef DEBUG
  if (no > RANK || no < 1) {
      fprintf(stderr, "vertex must be between 1 and %d.\n",RANK);
      exit(1);
  }
#endif

  switch(no) {
  case 1: return(0);
	break;
  case 2: return(1);
        break;
  }  
}

Vertex iota(Vertex no)
     /* Dynkin diagram involution */
{

#ifdef DEBUG
  if (no >= RANK) {
      fprintf(stderr, "vertex must be between 1 and %d.\n",RANK);
      exit(1);
  }
#endif

  switch(no) {
  case 0: return(1);
    break;
  case 1: return(0);
  }  
}

/*
short int vertex_no(Vertex vertex)
{
  switch(vertex) {
  case 0: return(1);
	break;
  case 1: return(2);
	break;
  }
}
*/

short int exponent(Wttable vtable, Vertex vertex, Eigen eigen)
{
  short int e;

  e = highestweight[vertex][eigen];
  if (eigen < EIG_MAX - 1) e -= vtable[vertex][eigen+1];
  if (eigen > 0) e -= vtable[vertex][eigen-1];

  switch(vertex) {
  case 0: return(e + vtable[1][eigen]);
    break;
  case 1: return(e + vtable[0][eigen]);
    break;
  }
}  

#ifdef COMMENT
mul_A_sub(Wttable table, Vertex vertex, Eigen eigen,short int add)
     /*     Wttable table;
     short int vertex;
     short int eigen;
     short int add; */

{
  switch(vertex) {
  case 0: dainyuu(table,1,eigen+1,add);
    break;
  case 1: dainyuu(table,0,eigen+1,add);
    break;
  }
}  
#endif

boolean Cinv(Weight weight1, Weight weight2)
     /* Calculate weight2 = C^{-1} weight1.
	Return FALSE if it is not integer valued. */
{
  Vertex vertex;
  short int s;

  weight2[0] = weight1[0]*2 + weight1[1];
  if ((weight2[0] % 3 != 0) || weight2[0] < 0) return(FALSE);
  else weight2[0] = weight2[0]/3;

  weight2[1] = weight1[0] + weight1[1]*2;
  if ((weight2[1] % 3 != 0) || weight2[1] < 0) return(FALSE);
  else weight2[1] = weight2[1]/3;

  return(TRUE);

}



/*
                                     [ 2    -1]
                                C := [        ]
                                     [-1     2]

> inverse(C);
                                 [2/3    1/3]
                                 [          ]
                                 [1/3    2/3]

*/
