#include "qchar.h"
/* extern void clear_table(Wttable table); */

unsigned short int read_depth(FILE *file)
{
  unsigned short int dep_w;

  if (fread(&dep_w, sizeof dep_w, 1, file) == 0) 
    return(DEPTH_MAX);
  return(dep_w);
}

#ifndef EULER
void fread_P(FILE *file, Poincare p)
{
  unsigned short int t;
  unsigned short int a;

  for(t=0; t < COMP_DIM_MAX; t++)
    p[t] = 0;

  do {
    fread(&t, sizeof t, 1, file);
    fread(&a, sizeof a, 1, file);

    if (a == 0) break;

    p[t] = a;
  } while(TRUE);
}
#endif

#ifndef EULER
void fwrite_P(FILE *file, Poincare p)
{
  unsigned short int t = 0;
  unsigned short int a;
 
  for(t=0; t < COMP_DIM_MAX; t++)
    if ((a = p[t]) != 0) {
      fwrite(&t, sizeof t,1, file);
      fwrite(&a, sizeof a,1, file);

      /* fprintf(file, "%d %d ", t,a); */
    }

  t = a = 0;
  fwrite(&t, sizeof t,1, file);
  fwrite(&a, sizeof a,1, file);

  /* fprintf(file, "   "); */
}
#endif

#ifdef COMMENT
/* write table to file */
void write_table_tofile(Wttable table, FILE *file)
{
  Vertex i;
  Eigen j;
  short int a;
  Qweight_cont q;

  for (i=0; i<RANK; i++)
    for (j=0; j < EIG_MAX; j++)
      if ((a = table[i][j]) != 0) {
	q = i + ieigen(j) + iexpo(a);

	fwrite(&q, sizeof q, 1, file);
	/*
	if (j > 9) fprintf(file, " %d_{%d}",i+1,j);
	else fprintf(file, " %d_%d",i+1,j);
	if (a > 1 && a < 10) fprintf(file, "^%d", a);
	else if (a != 1) fprintf(file, "^{%d}",a);
	*/
      }
  q = 0;
  fwrite(&q, sizeof q, 1, file);
  /* fprintf(file, "\n"); */

}
#endif

void display_qwt_tofile(Qweight qwt, FILE *file)
{
  unsigned int i = 0;
  Qweight_cont q;

  while (((q = qwt[i++]) & LAST) != LAST)
    fwrite(&q, sizeof q, 1, file);
  fwrite(&q, sizeof q, 1, file);

}

#ifdef COMMENT
void read_table_fromfile(Wttable table, FILE *file)
{
  Qweight_cont q;

  clear_table(table);
  do {
    fread(&q, sizeof q, 1, file);
    if ((q & LAST) == LAST) break;
    table[vertexf(q)][eigenf(q)] = expo(q);
  } while(TRUE);
}
#endif

void read_qwt_fromfile(Qweight qwt, FILE *file)
{
  unsigned int i = 0;
  Qweight_cont q;

  do {
    fread(&q, sizeof q, 1, file);
    qwt[i++] = q;
    if ((q & LAST) == LAST) break;
  } while(TRUE);
}
