#include <string.h>
#include <stdio.h>

#ifndef boolean
#define boolean unsigned short int
#endif

#define TRUE 1
#define FALSE 0

#define MINUS_ONE 0xFFFFFFFF

#undef max
#define max(a,b) ((a) > (b) ? (a) : (b))

#undef min
#define min(a,b) ((a) < (b) ? (a) : (b))

#define Vertex unsigned short int
#define Eigen unsigned short int

/* `vertex' uses the last 4bits 000000000000****.
   `vertex' must be between 0 and 0x0F = 15 */
#define vertexf(a)  ((a) & 0x000F)

/* `eigen' uses middle 6 bits 000000******0000.
   `eigen' must be between 0 and 0x3F = 63 */
#define eigenf(a)   (((a) & 0x03F0) >> 4)
#define ieigen(a) (((a) & 0x003F) << 4)

#define LAST 0x0FFF
/* This LAST is used for special purpose. */

/* expo use the first 6 bits ******0000000000. 
   expo must be between -63 and +63 */
/* #define expo(a) ((a) < 0x8100 ? ((a) & 0xFC00) >> 10\ */
/* : (((a) & 0xFC00) >> 10)-64) */

/* #define iexpo(a)  ((a) > 0 ? ((a) & 0x003F) << 10 : ((0x0040 + (a)) & 0x003F) << 10) */

#define Qweight_cont unsigned short int
typedef Qweight_cont Qweight[DEPTH_MAX];

typedef short int Weight[RANK];
typedef short int Wttable[RANK][EIG_MAX];

#define dainyuu(table,vertex,eigen,add) table[vertex][eigen] += add

struct Range {
  short int low;
  short int high;
};

#ifdef EULER
typedef signed short int Poincare;
typedef signed long int PoincareLong;
#else
typedef signed short int Poincare[COMP_DIM_MAX];
typedef signed long int PoincareLong[COMP_DIM_MAX];
#endif
/* COMP_DIM_MAX must be the actual complex dimension of the graded
   quiver variety + 1 to remember Betti numbers from 0, .. , dim.
   (e.g., CP^1 --> COMP_DIM_MAX = 2) */

#ifdef EULER
#define equal_P(p1,p2) ((p1 == p2))
#define subst_P(p1,p2) (p1 = p2)
#define add_P(p1,p2,p3) (p3 = p1 + p2)
#define subtr_P(p1,p2,p3) (p3 = p1 - p2)
#define subadd_P(p1,p2) (p1 += p2)
#define mul_P(p1,p2,p3) (p3 = p1 * p2)
#define fread_P(file, p) fread(&(p), sizeof (p), 1, file)
#define fwrite_P(file, p) fwrite(&(p), sizeof (p), 1, file)
#define subst_PL(p1,p2) (p1 = p2)
#define subadd_PL(p1,p2) (p1 += p2)
#endif

#define byte_P(vertex) (0x0001 << vertex)
#define bit_P(p, vertex) ((p >> vertex) & 0x0001)

/* The following 3 definitions were moved from table.c */
#define sub_table(table1, table2) memcpy(table1, table2, sizeof (Wttable))
#ifdef COMMENT
void sub_table(Wttable table1, Wttable table2)
{
  Vertex i;
  Eigen j;

  for (i = 0; i < RANK; i++)
    for (j = 0; j < EIG_MAX; j++)
      table1[i][j] = table2[i][j];
}
#endif

#define clear_table(table) bzero(table, sizeof (Wttable))
#ifdef COMMENT
void clear_table(Wttable table)
{
  Vertex i;
  Eigen j;

  for (i = 0; i < RANK; i++)
    for (j = 0; j < EIG_MAX; j++)
      table[i][j] = 0;
}
#endif

#define eq_table(table1, table2) !bcmp(table1, table2, sizeof (Wttable))
#ifdef COMMENT
boolean eq_table(Wttable table1, Wttable table2)
{
  Vertex i;
  Eigen j;

  for (i = 0; i < RANK; i++)
    for (j = 0; j < EIG_MAX; j++)
      if (table1[i][j] != table2[i][j]) return(FALSE);
  return(TRUE);
}
#endif

/* The following come from Poincare.c */
#ifndef EULER
#define subst_P(p1, p2) memcpy(p1, p2, sizeof (Poincare))
#define subst_PL(p1, p2) memcpy(p1, p2, sizeof (PoincareLong))
/*
void subst_P(Poincare p1, Poincare p2)
{
  unsigned short int t = 0;

  for (t = 0; t<COMP_DIM_MAX; t++)
  p1[t] = p2[t];
}
*/
#endif

#define subst_IP(p1, p2) memcpy(p1, p2, sizeof (Poincare)*RANK)
/*
void subst_IP(Poincare p1[], Poincare p2[])
{
  memcpy(p1, p2, sizeof (Poincare)*RANK);
}
*/

