#include "stdlib.h"
#include "ctype.h"
#include "sys/types.h"
#include "qchar.h"

extern Wttable highestweight;
extern Qweight hwt;
extern Weight WEIGHT;

void read_hwt(char *str)
{
  unsigned int i = 0;
  Vertex vertex;
  Eigen eigen;
  unsigned int a;
  Qweight_cont temp;

  while (*str != '\0') {

    if (!isdigit(*str)) usage(); 

	/*    if ((temp = atoi(str)-1) >= RANK) {
      fprintf(stderr, "vertex must be between 1 and %d.\n",RANK);
      exit(1);
    } */

	temp = no_vertex(atoi(str));

    while (isdigit(*str)) str++;
    if (*str++ != ',') usage();
    if (atoi(str) < 0 || atoi(str) + DUAL_COXETER >= EIG_MAX) {
      fprintf(stderr, "eigen_value must be between 0 and %d.\n",
	      EIG_MAX - DUAL_COXETER - 1);
      exit(1);
    } 
    temp += ieigen(atoi(str));

    while (isdigit(*str)) str++;
    if (*str++ != ',') usage();
    if (atoi(str) < 1) {
      fprintf(stderr, "l-highest weight must be l-dominant.\n");
      exit(1);
    }
    for (a=atoi(str); a > 0; a--) hwt[i++] = temp;
    
    while (isdigit(*str)) str++;
    if (*str == ',') str++;
  }
  hwt[i] = LAST;
  /* display_qwt(hwt); */

  /* put into highestweight */
  clear_table(highestweight);
  i = 0;
  while (hwt[i] != LAST) {
    highestweight[vertexf(hwt[i])][eigenf(hwt[i])]++;
    i++;
  }

  /* sort highest weight */
  i = 0;
  for (eigen = 0; eigen < EIG_MAX; eigen++)
    for (vertex = 0; vertex < RANK; vertex++)
      for (a = highestweight[vertex][eigen]; a > 0; a--)
	hwt[i++] = ieigen(eigen) + vertex;
  hwt[i] = LAST;
}

void str2weight(char *str)
{
  Vertex vertex = 0;
  short int sign;
  
  do  {
    sign = (*str == '-' && str++) ? -1 : 1;
    if (!isdigit(*str)) usage();
    WEIGHT[no_vertex(vertex+1)] = sign*atoi(str);
    while (isdigit(*str)) str++;
    switch (*str) {
    case '\0':
      return;
    case ',':
      str++;
      break;
    default:
      usage();
    }
  } while (++vertex < RANK);
}

void dim_range(char *str, struct Range *range)
{
  if (isdigit(*str)) range->low = atoi(str);
  else usage();
  while (isdigit(*str)) str++;
  switch (*str) {
  case '\0':
    range->high = -1;
    break;
  case ',':
    if (isdigit(*(++str))) range->high = atoi(str);
    else usage();
    break;
  default:
    usage();
  }
}  

